文章目录
1. 题目描述
给你一个整数数组 arr
和一个整数 difference
,请你找出并返回 arr 中最长等差子序列的长度,该子序列中相邻元素之间的差等于 difference
。
子序列 是指在不改变其余元素顺序的情况下,通过删除一些元素或不删除任何元素而从 arr 派生出来的序列。
示例 1:
输入:arr = [1,2,3,4], difference = 1
输出:4
解释:最长的等差子序列是 [1,2,3,4]。
示例 2:
输入:arr = [1,3,5,7], difference = 1
输出:1
解释:最长的等差子序列是任意单个元素。
示例 3:
输入:arr = [1,5,7,8,5,3,4,2,1], difference = -2
输出:4
解释:最长的等差子序列是 [7,5,3,1]。
提示:
1 <= arr.length <= 1 0 5 10^5 105
- 1 0 4 10^4 104<= arr[i], difference <= 1 0 4 10^4 104
2. 题解
2.1 暴力求解
按照题意首先想到的是模拟这个流程进行贪心的求解,也就是模拟其求解过程,很容易写出代码:
public int longestSubsequence(int[] arr, int difference) {
int len = arr.length;
int max = 0;
for (int i = 0; i < len; i++) {
int cur = arr[i];
int count = 0;
for (int j = i + 1; j < len; j++) {
if(cur + difference == arr[j]){
cur = arr[j];
count++;
}
}
max = Math.max(max, count);
}
return max;
}
不出意外,最终超时了,结果如下:
2.2 动态规划
我们直接用dp[v]
表示以 v
为结尾的最长的等差子序列的长度,这样 dp[v−d]
就是我们要找的左侧元素对应的最长的等差子序列的长度,因此转移方程可以改为:dp[v]=dp[v−d]+1
最后答案为 max{dp}
。
public int longestSubsequence(int[] arr, int difference) {
int max = 0;
Map<Integer, Integer> dp = new HashMap<>();
for (int j : arr) {
dp.put(j, dp.getOrDefault(j - difference, 0) + 1);
max = Math.max(max, dp.get(j));
}
return max;
}
使用在遍历的过程中进行put
元素,可以很巧妙的避开重复元素的影响。
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/longest-arithmetic-subsequence-of-given-difference